#!/usr/bin/env python3
"""
Polarized GISAS (PM spin-flip channel) of a rotated magnetic sphere.

A sphere with x-oriented magnetisation is rotated 20° around Z and
suspended in a substrate with y-oriented magnetisation. The out-of-plane
magnetisation component opens a spin-flip channel (PM: +Z polariser,
-Z analyser).
"""
import bornagain as ba
from bornagain import ba_plot as bp, deg, nm, R3


def get_sample():
    vacuum = ba.Vacuum()
    substrate_color = (0.28, 0.57, 0.82)
    substrate_mat = ba.RefractiveMaterial("Substrate", substrate_color, 7e-6, 2e-8,
                                                R3(0, 1e6, 0))
    particle_color = (0.86, 0.24, 0.18)
    particle_mat = ba.RefractiveMaterial("MagParticle", particle_color, 6e-4, 2e-8,
                                               R3(1e6, 0, 0))

    ff = ba.Sphere(5*nm)
    particle = ba.Particle(particle_mat, ff)
    particle.rotate(ba.RotationZ(20*deg))

    vacuum_layer = ba.Layer(vacuum)
    substrate_layer = ba.Layer(substrate_mat)
    substrate_layer.suspend2D(ba.Dilute2D(0.001, particle))

    sample = ba.Sample()
    sample.addLayer(vacuum_layer)
    sample.addLayer(substrate_layer)
    return sample


def get_simulation(sample):
    beam = ba.Beam(1e9, 0.1*nm, 0.2*deg)
    n = 200
    detector = ba.SphericalDetector(n, -2*deg, 2*deg, n, 0, 2*deg)
    beam.setPolarization(R3(0, 0, 1))
    detector.setAnalyzer(R3(0, 0, -1))
    return ba.ScatteringSimulation(beam, sample, detector)


if __name__ == '__main__':
    sample = get_sample()
    simulation = get_simulation(sample)
    result = simulation.simulate()
    plotargs = bp.parse_commandline()
    bp.plot_datafield(result, unit_aspect=1, **plotargs)
    bp.export(**plotargs)
